ArcRepair = LibStub("AceAddon-3.0"):NewAddon("ArcRepair", "AceEvent-3.0", "AceConsole-3.0")

local options = {
	name = "ArcRepair",
	handler = ArcRepair,
	type = "group",
	args = {
		Enable = {
			type = "toggle",
			name = "Enable",
			desc = "Enables or Disables automatic repairs",
			order = 1,
			get = "GetEnabled",
			set = "ToggleEnabled"
		},
		oneheader = {
			type = "header",
			name = "Toggle Days",
			order = 2
		},
		Sunday = {
			type = "toggle",
			name = "Sunday",
			desc = "Toggles Guild Repairs on Sunday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 3,
		},
		Monday = {
			type = "toggle",
			name = "Monday",
			desc = "Toggles Guild Repairs on Monday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 4,
		},
		Tuesday = {
			type = "toggle",
			name = "Tuesday",
			desc = "Toggles Guild Repairs on Tuesday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 5,
		},
		Wednesday = {
			type = "toggle",
			name = "Wednesday",
			desc = "Toggles Guild Repairs on Wednesday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 6,
		},
		Thursday = {
			type = "toggle",
			name = "Thursday",
			desc = "Toggles Guild Repairs on Thursday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 7,
		},
		Friday = {
			type = "toggle",
			name = "Friday",
			desc = "Toggles Guild Repairs on Friday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 8,
		},
		Saturday = {
			type = "toggle",
			name = "Saturday",
			desc = "Toggles Guild Repairs on Saturday",
			get = "GetDayEnabled",
			set = "ToggleDay",
			order = 9,
		},
	},
}

local defaults = {
	profile = {
		Sunday = true,
		Monday = false,
		Tuesday = true,
		Wednesday = true,
		Thursday = false,
		Friday = false,
		Saturday = true,
		enabled = true,
	},
	
}

local days = {
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
}

function ArcRepair:OnEnable()
	self:RegisterEvent("MERCHANT_SHOW", "RepairItems")
end

function ArcRepair:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ArcRepairSaved", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ArcRepair", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ArcRepair", "ArcRepair")
	self:RegisterChatCommand("arcrepair", "ChatCommand")
	self:RegisterChatCommand("ar", "ChatCommand")
end

function ArcRepair:RepairItems()
	if(CanMerchantRepair() and self.db.profile.enabled) then
		local cost, canRepair = GetRepairAllCost()
		local grepair = CanGuildBankRepair()
		
		-- Blizzard broke CalendarGetDate(), so now we have to find out our weekday the hard way. 
		-- local day = CalendarGetDate()
		local zeroggblizz, month, mday, year = CalendarGetDate()
		local fmonth, fyear, fday, fweek = CalendarGetMonth()
		day =  (mday - (8 - fweek))%7
		
		if(grepair) then
			if(self.db.profile[days[day]]) then
				grepair = true
			else
				grepair = false
			end
		end
		
		if(grepair and cost > GetGuildBankMoney()) then
			self:Print("Your Guild Bank does not have enough gold to cover your repairs.")
			grepair = false
		elseif(grepair and cost > GetGuildBankWithdrawMoney()) then
			self:Print("Your repair costs exceed your remaining daily Guild Bank limit")
			grepair = false
		end
		
		if(canRepair) then
			RepairAllItems(grepair)
			
			if(grepair) then
				repairmessage = "Repaired from Guild Bank for: "
			else
				repairmessage = "Repaired from your wallet for: "
			end
			
			self:Print(repairmessage..GetCoinTextureString(cost))
		end
	end
end

function ArcRepair:ToggleDay(info, value)
	if(self.db.profile[info[#info]]) then
		self.db.profile[info[#info]] = false
	else
		self.db.profile[info[#info]] = true
	end
end

function ArcRepair:GetDayEnabled(info)
	return self.db.profile[info[#info]]
end

function ArcRepair:ChatCommand(input)
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end

function ArcRepair:GetEnabled(info)
	return self.db.profile.enabled
end

function ArcRepair:ToggleEnabled(info, value)
	if(self.db.profile.enabled) then
		self.db.profile.enabled = false
	else
		self.db.profile.enabled = true
	end
end